## netgen 6.2.1804+dfsg1

=== CMakeLists.txt ===
if(NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE "RelWithDebInfo" CACHE STRING INTERNAL)
endif(NOT CMAKE_BUILD_TYPE)

cmake_minimum_required(VERSION 3.1.3)
if(NOT WIN32)
    option( USE_NATIVE_ARCH  "build which -march=native" ON)
endif(NOT WIN32)

option( USE_GUI     "don't build netgen with GUI" ON )
option( USE_PYTHON  "build with python interface" ON )
option( USE_MPI     "enable mpi parallelization" OFF )
option( USE_OCC     "(not supported) compile with OpenCascade geometry kernel" OFF)
option( USE_JPEG    "enable snapshots using library libjpeg" OFF )
option( USE_MPEG    "enable video recording with FFmpeg, uses libavcodec" OFF )
option( INTEL_MIC        "cross compile for intel xeon phi")
option( INSTALL_PROFILES "install environment variable settings to /etc/profile.d" OFF )
option( USE_CCACHE       "use ccache")
option( USE_INTERNAL_TCL "Compile tcl files into the code and don't install them" ON)

option( USE_SUPERBUILD       "use ccache" ON)

set(CMAKE_MODULE_PATH "${CMAKE_MODULE_PATH}" "${CMAKE_CURRENT_SOURCE_DIR}/cmake/cmake_modules")

if(APPLE)
  set(INSTALL_DIR_DEFAULT /Applications/Netgen.app)
else(APPLE)
  if(WIN32)
    set(INSTALL_DIR_DEFAULT "C:/netgen")
  else(WIN32)
    set(INSTALL_DIR_DEFAULT /opt/netgen)
  endif(WIN32)
endif(APPLE)

if(INSTALL_DIR)
  message(WARNING "INSTALL_DIR is deprecated, use CMAKE_INSTALL_PREFIX instead")
  set(INSTALL_DIR_DEFAULT ${INSTALL_DIR})
endif(INSTALL_DIR)

if(UNIX)
  message("Checking for write permissions in install directory...")
  execute_process(COMMAND mkdir -p ${CMAKE_INSTALL_PREFIX})
  execute_process(COMMAND test -w ${CMAKE_INSTALL_PREFIX} RESULT_VARIABLE res)
  if(res)
    message(WARNING "No write access at install directory, please set correct permissions")
  endif()
endif(UNIX)

if (USE_SUPERBUILD)
  project (SUPERBUILD)
  if (CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
    set(CMAKE_INSTALL_PREFIX "${INSTALL_DIR_DEFAULT}" CACHE PATH "Install directory" FORCE)
  endif()

  # execute the superbuild (this script will be invoked again without the
  # USE_SUPERBUILD option this time)
  include (cmake/SuperBuild.cmake)
  return()                      # stop processing this file further
else()
  project(Netgen)
  if (CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
    set(CMAKE_INSTALL_PREFIX "${INSTALL_DIR_DEFAULT}" CACHE PATH "Install directory" FORCE)
  endif()
endif()

set(NETGEN_VERSION_MAJOR 6)
set(NETGEN_VERSION_MINOR 2)
string(TIMESTAMP NETGEN_VERSION_PATCH "%y%U%w" )
set(NETGEN_VERSION "${NETGEN_VERSION_MAJOR}.${NETGEN_VERSION_MINOR}-dev")
set(PACKAGE_VERSION "${NETGEN_VERSION_MAJOR}.${NETGEN_VERSION_MINOR}-${NETGEN_VERSION_PATCH}")
set(CPACK_PACKAGE_VERSION "${PACKAGE_VERSION}")


#######################################################################
if(USE_CCACHE)
  find_program(CCACHE_FOUND NAMES ccache ccache.bat)
  if(CCACHE_FOUND)
    set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE ${CCACHE_FOUND})
  endif(CCACHE_FOUND)
endif(USE_CCACHE)

#######################################################################
if(USE_NATIVE_ARCH)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -march=native")
endif(USE_NATIVE_ARCH)

#######################################################################
if(INTEL_MIC)
    set(MKL_ARCH "mic")
    include(cmake/mic.cmake)
else(INTEL_MIC)
    set(MKL_ARCH "intel64")
endif(INTEL_MIC)

#######################################################################
# Append install paths of software in non-standard paths (e.g. openmpi, metis, intel mkl, ...)
# cmake -DUSE_MPI=ON -DCMAKE_PREFIX_PATH="/opt/openmpi165;/opt/metis51" ../
set(ADDITIONAL_PATHS "" CACHE PATH "List of paths to additional libraries in non-standard locations, separated by ';'")
if (ADDITIONAL_PATHS)
  set(CMAKE_PREFIX_PATH ${ADDITIONAL_PATHS})
endif (ADDITIONAL_PATHS)

#######################################################################
# build options
include_directories ("${PROJECT_SOURCE_DIR}/include")
include_directories ("${PROJECT_SOURCE_DIR}/libsrc/include")
include_directories ("${PROJECT_BINARY_DIR}")

set(CMAKE_INCLUDE_CURRENT_DIR ON)

if(USE_PYTHON)
    find_package(PythonInterp 3 REQUIRED)
    find_package(PythonLibs 3 REQUIRED)

    execute_process(COMMAND ${PYTHON_EXECUTABLE} -c "from distutils.sysconfig import get_python_lib; print(get_python_lib(1,0,''))" OUTPUT_VARIABLE PYTHON_PACKAGES_INSTALL_DIR OUTPUT_STRIP_TRAILING_WHITESPACE)
    file(TO_CMAKE_PATH ${PYTHON_PACKAGES_INSTALL_DIR} PYTHON_PACKAGES_INSTALL_DIR)
endif(USE_PYTHON)

set(NG_INSTALL_SUFFIX netgen CACHE STRING "Suffix appended to install directories (project name)")

if(APPLE)
  set(NG_INSTALL_DIR_BIN_DEFAULT Contents/MacOS)
  set(NG_INSTALL_DIR_LIB_DEFAULT Contents/MacOS)
  set(NG_INSTALL_DIR_CMAKE_DEFAULT Contents/Resources/CMake)
  set(NG_INSTALL_DIR_PYTHON_DEFAULT Contents/Resources/${PYTHON_PACKAGES_INSTALL_DIR})
  set(NG_INSTALL_DIR_RES_DEFAULT Contents/Resources/share)
  set(NG_INSTALL_DIR_INCLUDE_DEFAULT Contents/Resources/include)

  set(NG_RPATH_TOKEN "@loader_path")
else(APPLE)
  set(NG_INSTALL_DIR_BIN_DEFAULT bin)
  set(NG_INSTALL_DIR_LIB_DEFAULT lib)
  if(WIN32)
    set(NG_INSTALL_DIR_CMAKE_DEFAULT cmake)
  else(WIN32)
    set(NG_INSTALL_DIR_CMAKE_DEFAULT lib/cmake/${NG_INSTALL_SUFFIX})
  endif(WIN32)
  set(NG_INSTALL_DIR_PYTHON_DEFAULT ${PYTHON_PACKAGES_INSTALL_DIR})
  set(NG_INSTALL_DIR_RES_DEFAULT share)
  set(NG_INSTALL_DIR_INCLUDE_DEFAULT include)

  set(NG_RPATH_TOKEN "\$ORIGIN")
endif(APPLE)

set(NG_INSTALL_DIR_PYTHON ${NG_INSTALL_DIR_PYTHON_DEFAULT} CACHE STRING "Install directory for Python files")
set(NG_INSTALL_DIR_BIN ${NG_INSTALL_DIR_BIN_DEFAULT} CACHE STRING "Install directory for executables")
set(NG_INSTALL_DIR_LIB ${NG_INSTALL_DIR_LIB_DEFAULT} CACHE STRING "Install directory for libraries")
set(NG_INSTALL_DIR_INCLUDE ${NG_INSTALL_DIR_INCLUDE_DEFAULT} CACHE STRING "Install directory for header files")
set(NG_INSTALL_DIR_CMAKE ${NG_INSTALL_DIR_CMAKE_DEFAULT} CACHE STRING "Install directory for CMake files")
set(NG_INSTALL_DIR_RES ${NG_INSTALL_DIR_RES_DEFAULT} CACHE STRING "Install directory for resources")

get_filename_component(NETGEN_CMAKE_DIR_ABSOLUTE ${NG_INSTALL_DIR_CMAKE} ABSOLUTE BASE_DIR ${CMAKE_INSTALL_PREFIX})
get_filename_component(NETGEN_BINARY_DIR_ABSOLUTE ${NG_INSTALL_DIR_BIN} ABSOLUTE BASE_DIR ${CMAKE_INSTALL_PREFIX})
get_filename_component(NETGEN_LIBRARY_DIR_ABSOLUTE ${NG_INSTALL_DIR_LIB} ABSOLUTE BASE_DIR ${CMAKE_INSTALL_PREFIX})
get_filename_component(NETGEN_INCLUDE_DIR_ABSOLUTE ${NG_INSTALL_DIR_INCLUDE} ABSOLUTE BASE_DIR ${CMAKE_INSTALL_PREFIX})
get_filename_component(NETGEN_RESOURCE_DIR_ABSOLUTE ${NG_INSTALL_DIR_RES} ABSOLUTE BASE_DIR ${CMAKE_INSTALL_PREFIX})

file(RELATIVE_PATH NETGEN_DIR ${NETGEN_CMAKE_DIR_ABSOLUTE} ${CMAKE_INSTALL_PREFIX})
file(RELATIVE_PATH NETGEN_BINARY_DIR ${NETGEN_CMAKE_DIR_ABSOLUTE} ${NETGEN_BINARY_DIR_ABSOLUTE})
file(RELATIVE_PATH NETGEN_LIBRARY_DIR ${NETGEN_CMAKE_DIR_ABSOLUTE} ${NETGEN_LIBRARY_DIR_ABSOLUTE})
file(RELATIVE_PATH NETGEN_INCLUDE_DIR ${NETGEN_CMAKE_DIR_ABSOLUTE} ${NETGEN_INCLUDE_DIR_ABSOLUTE})
file(RELATIVE_PATH NETGEN_RESOURCE_DIR ${NETGEN_CMAKE_DIR_ABSOLUTE} ${NETGEN_RESOURCE_DIR_ABSOLUTE})

file(RELATIVE_PATH NETGEN_RPATH ${NETGEN_BINARY_DIR_ABSOLUTE} ${NETGEN_LIBRARY_DIR_ABSOLUTE})

if(USE_PYTHON)
    get_filename_component(NETGEN_PYTHON_DIR_ABSOLUTE ${NG_INSTALL_DIR_PYTHON} ABSOLUTE BASE_DIR ${CMAKE_INSTALL_PREFIX})
    file(RELATIVE_PATH NETGEN_PYTHON_DIR ${NETGEN_CMAKE_DIR_ABSOLUTE} ${NETGEN_PYTHON_DIR_ABSOLUTE})
    file(RELATIVE_PATH NETGEN_PYTHON_RPATH_BIN ${NETGEN_PYTHON_DIR_ABSOLUTE} ${NETGEN_BINARY_DIR_ABSOLUTE})
    file(RELATIVE_PATH NETGEN_PYTHON_RPATH ${NETGEN_PYTHON_DIR_ABSOLUTE} ${NETGEN_LIBRARY_DIR_ABSOLUTE})
    if(WIN32)
        set(NETGEN_PYTHON_RPATH ${NETGEN_PYTHON_RPATH_BIN})
    endif(WIN32)
endif(USE_PYTHON)

set(NG_INSTALL_DIR EXPORT netgen-targets RUNTIME DESTINATION ${NG_INSTALL_DIR_BIN} COMPONENT netgen LIBRARY DESTINATION ${NG_INSTALL_DIR_LIB} COMPONENT netgen_devel ARCHIVE DESTINATION ${NG_INSTALL_DIR_LIB} COMPONENT netgen_devel)
install(EXPORT netgen-targets DESTINATION ${NG_INSTALL_DIR_CMAKE} COMPONENT netgen_devel)

set(CMAKE_MACOSX_RPATH TRUE)
set(CMAKE_INSTALL_RPATH "${NG_RPATH_TOKEN};${NG_RPATH_TOKEN}/${NETGEN_RPATH}")

include (CheckIncludeFiles)
check_include_files (dlfcn.h HAVE_DLFCN_H)
if(HAVE_DLFCN_H)
  add_definitions(-DHAVE_DLFCN_H)
endif()
add_definitions(-DNETGEN_VERSION="${NETGEN_VERSION}")

include_directories(BEFORE ${CMAKE_CURRENT_BINARY_DIR})

#######################################################################
# platform specific definitions and flags
macro(get_WIN32_WINNT version)
    if (WIN32 AND CMAKE_SYSTEM_VERSION)
        if("${CMAKE_SYSTEM_VERSION}" MATCHES "^([0-9]+)\\.([0-9]+)")
            math(EXPR ver "${CMAKE_MATCH_1}*100 + ${CMAKE_MATCH_2}")
        endif()
        set(${version} "0x${ver}")
    endif()
endmacro()

macro(get_dll_from_lib dll_path lib_path)
        get_filename_component(parent_lib_path ${lib} DIRECTORY)
        get_filename_component(lib_name ${lib} name)
endmacro()

set(CMAKE_CXX_STANDARD 14)
if(WIN32)
    get_WIN32_WINNT(ver)
    add_definitions(-D_WIN32_WINNT=${ver} -DWNT -DWNT_WINDOW -DNOMINMAX)
    set(CMAKE_MFC_FLAG 0)
    add_definitions(-DMSVC_EXPRESS -D_CRT_SECURE_NO_WARNINGS -DHAVE_STRUCT_TIMESPEC)
    # build convenience (aka object) libraries in windows)
    set(NG_LIB_TYPE OBJECT)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /MP /wd4244 /wd4800")
else(WIN32)
    # build shared libraries
    set(NG_LIB_TYPE SHARED)
endif(WIN32)
if(APPLE)
    set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -undefined dynamic_lookup")
endif(APPLE)

#######################################################################
if(NOT ZLIB_INCLUDE_DIRS)
  find_package(ZLIB REQUIRED)
endif(NOT ZLIB_INCLUDE_DIRS)
include_directories(${ZLIB_INCLUDE_DIRS})

#######################################################################
if (USE_GUI)
    find_package(TCL 8.5 REQUIRED)
    find_package(Threads REQUIRED)
    if(APPLE)
          set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -framework AppKit")
    else(APPLE)
          find_package(X11 REQUIRED) 
    endif(APPLE)
    find_package(OpenGL REQUIRED)

    add_definitions(-DTCL -DOPENGL -DUSE_TOGL_2)
    include_directories(${TCL_INCLUDE_PATH})
    include_directories(${TK_INCLUDE_PATH})
    set(LIBTOGL togl)

    if(WIN32)
        add_definitions(-DTOGL_WGL)
    else(WIN32)
        if(APPLE)
                ADD_DEFINITIONS(-DTOGL_NSOPENGL)
        else(APPLE)
                ADD_DEFINITIONS(-DTOGL_X11)
        endif(APPLE)
    endif(WIN32)
endif (USE_GUI)

#######################################################################
if (USE_PYTHON)
    add_definitions(-DNG_PYTHON)
    find_path(PYBIND_INCLUDE_DIR pybind11/pybind11.h HINTS ${PYTHON_INCLUDE_DIR})
    if( PYBIND_INCLUDE_DIR )
        message(STATUS "Found Pybind11: ${PYBIND_INCLUDE_DIR}")
    else( PYBIND_INCLUDE_DIR )
        message(FATAL_ERROR "Could NOT find pybind11!")
    endif( PYBIND_INCLUDE_DIR )

    include_directories(${PYBIND_INCLUDE_DIR})
    include_directories(${PYTHON_INCLUDE_DIRS})

    if(NG_INSTALL_PYBIND)
      install(DIRECTORY ${PYBIND_INCLUDE_DIR}/pybind11 DESTINATION ${NG_INSTALL_DIR_INCLUDE} COMPONENT netgen_devel)
      install(FILES ${PYBIND_INCLUDE_DIR}/../LICENSE DESTINATION ${NG_INSTALL_DIR_INCLUDE}/pybind11 COMPONENT netgen_devel)
    endif(NG_INSTALL_PYBIND)
endif (USE_PYTHON)

#######################################################################
if (USE_MPI)
    find_package(MPI REQUIRED)
    find_package(METIS REQUIRED)
    add_definitions(-DPARALLEL -DMETIS)
    include_directories(${MPI_CXX_INCLUDE_PATH})
    include_directories(${METIS_INCLUDE_DIR})
endif (USE_MPI)

#######################################################################
if (USE_OCC)
    find_package(OpenCasCade REQUIRED)
    add_definitions(-DOCCGEOMETRY -D_OCC64)
    include_directories(${OCC_INCLUDE_DIR})
endif (USE_OCC)

=== libsrc/CMakeLists.txt ===
add_subdirectory(general)
add_subdirectory(gprim)
add_subdirectory(linalg)
add_subdirectory(include)
add_subdirectory(meshing)
add_subdirectory(visualization)
add_subdirectory(csg)
add_subdirectory(geom2d)
add_subdirectory(occ)
add_subdirectory(stlgeom)
add_subdirectory(interface)

=== ng/CMakeLists.txt ===
if(USE_INTERNAL_TCL)
  add_definitions(-DINTERNAL_TCL_DEFAULT=1)
else()
  add_definitions(-DINTERNAL_TCL_DEFAULT=0)
endif()

set(netgen_sources ngappinit.cpp onetcl.cpp)
if(WIN32)
    # add icon to netgen executable
    enable_language(RC)
    set(netgen_sources ${netgen_sources} ../windows/netgen.rc)
    # Don't use ccache here due to incompatibility with the resource compiler
    set_directory_properties(PROPERTIES RULE_LAUNCH_COMPILE "")
endif(WIN32)

if(USE_GUI)

    add_library(gui SHARED
        gui.cpp ngpkg.cpp demoview.cpp parallelfunc.cpp
        ../libsrc/stlgeom/stlpkg.cpp ../libsrc/visualization/visualpkg.cpp
        ../libsrc/csg/csgpkg.cpp ../libsrc/geom2d/geom2dpkg.cpp
        ../libsrc/occ/occpkg.cpp ../libsrc/occ/vsocc.cpp
    )

    add_executable(netgen ngappinit.cpp onetcl.cpp)

    target_link_libraries( gui PUBLIC nglib ${ZLIB_LIBRARIES} ${JPEG_LIBRARIES} ${FFMPEG_LIBRARIES} ${X11_X11_LIB} ${OCC_LIBRARIES} )
    target_link_libraries( gui PRIVATE ${LIBTOGL})

    target_link_libraries( netgen nglib gui )

    if(APPLE)
      # Leave decision about which tcl/tk version to use open to python (and it's tkinter package).
      # Thus, only link tcl/tk to the netgen executable and not to the gui library.
      target_link_libraries( netgen ${TK_LIBRARY} ${TCL_LIBRARY})
    else(APPLE)
      # On other systems assume that the found libraries are compatible with python/tkinter
      target_link_libraries( gui PUBLIC ${TK_LIBRARY} ${TCL_LIBRARY})
    endif(APPLE)

    if(NOT WIN32)
      target_link_libraries( netgen mesh stlvis stl geom2dvis interface geom2d csg stl visual csgvis )
      target_link_libraries( gui PUBLIC mesh stlvis stl geom2dvis interface geom2d csg stl visual csgvis )
    endif(NOT WIN32)

    install(TARGETS netgen ${NG_INSTALL_DIR})
    install(TARGETS gui ${NG_INSTALL_DIR})

    if(APPLE)
        set_target_properties(netgen PROPERTIES OUTPUT_NAME netgen)
    endif(APPLE)
    if(WIN32)
        set_target_properties( gui PROPERTIES OUTPUT_NAME libgui )
    endif(WIN32)

endif(USE_GUI)

if(USE_PYTHON)
    add_library(ngpy SHARED netgenpy.cpp)
    target_link_libraries( ngpy nglib )
    if(APPLE)
        set_target_properties( ngpy PROPERTIES SUFFIX ".so")
    elseif(WIN32)
        set_target_properties( ngpy PROPERTIES SUFFIX ".pyd")
        set_target_properties( ngpy PROPERTIES OUTPUT_NAME "libngpy")
    endif()
    set_target_properties(ngpy PROPERTIES INSTALL_RPATH "${NG_RPATH_TOKEN}/../${NETGEN_PYTHON_RPATH}")
    install(TARGETS ngpy DESTINATION ${NG_INSTALL_DIR_PYTHON}/${NG_INSTALL_SUFFIX} COMPONENT netgen)
endif(USE_PYTHON)

if(USE_GUI)
  if(NOT USE_INTERNAL_TCL)
    install(FILES
        dialog.tcl menustat.tcl ngicon.tcl ng.tcl
        ngvisual.tcl sockets.tcl nghelp.tcl ngshell.tcl
        ngtesting.tcl parameters.tcl variables.tcl csgeom.tcl stlgeom.tcl
        occgeom.tcl acisgeom.tcl netgen.ocf drawing.tcl
        DESTINATION ${NG_INSTALL_DIR_BIN} COMPONENT netgen)
  endif()

  add_subdirectory(Togl2.1)
endif(USE_GUI)

=== nglib/CMakeLists.txt ===
add_definitions(-DNGLIB_EXPORTS)

if(WIN32)
    set(nglib_objects 
          $<TARGET_OBJECTS:mesh>
          $<TARGET_OBJECTS:stl>
          $<TARGET_OBJECTS:interface>
          $<TARGET_OBJECTS:geom2d>
          $<TARGET_OBJECTS:csg>
          $<TARGET_OBJECTS:stl>
          $<TARGET_OBJECTS:gen>
          $<TARGET_OBJECTS:la>
          $<TARGET_OBJECTS:gprim>

          $<TARGET_OBJECTS:visual>
          $<TARGET_OBJECTS:occ>
       )
       if(USE_GUI)
           set(nglib_objects ${nglib_objects}
	       $<TARGET_OBJECTS:stlvis>
	       $<TARGET_OBJECTS:geom2dvis>
               $<TARGET_OBJECTS:csgvis>
           )
       endif(USE_GUI)
endif(WIN32)

add_library(nglib SHARED nglib.cpp ${nglib_objects})
if(NOT WIN32)
      target_link_libraries( nglib mesh stl interface geom2d csg stl visual)
      if(USE_GUI)
          target_link_libraries( nglib stlvis geom2dvis csgvis )
      endif(USE_GUI)
endif(NOT WIN32)

target_link_libraries( nglib ${OCC_LIBRARIES} ${MPI_CXX_LIBRARIES} ${OPENGL_LIBRARIES} ${CMAKE_THREAD_LIBS_INIT} ${X11_Xmu_LIB} ${JPEG_LIBRARIES} ${MKL_LIBRARIES} ${ZLIB_LIBRARIES} ${OCC_LIBRARIES} )

if(USE_OCC AND NOT WIN32)
    target_link_libraries(nglib occ)
endif(USE_OCC AND NOT WIN32)

if(USE_PYTHON)
    target_link_libraries(nglib ${PYTHON_LIBRARIES})
endif(USE_PYTHON)

install(TARGETS nglib ${NG_INSTALL_DIR})
install(FILES nglib.h DESTINATION ${NG_INSTALL_DIR_INCLUDE} COMPONENT netgen_devel)

=== tests/CMakeLists.txt ===
add_subdirectory(pytest)

=== libsrc/csg/CMakeLists.txt ===
add_definitions(-DNGINTERFACE_EXPORTS)
add_library(csg ${NG_LIB_TYPE}
        algprim.cpp brick.cpp   
        bspline2d.cpp csgeom.cpp csgparser.cpp curve2d.cpp edgeflw.cpp	       
        explicitcurve2d.cpp extrusion.cpp gencyl.cpp genmesh.cpp identify.cpp  
        manifold.cpp meshsurf.cpp polyhedra.cpp revolution.cpp singularref.cpp 
        solid.cpp specpoin.cpp spline3d.cpp surface.cpp triapprox.cpp zrefine.cpp 
        python_csg.cpp splinesurface.cpp
        )
if(APPLE)
    set_target_properties( csg PROPERTIES SUFFIX ".so")
endif(APPLE)

if(NOT WIN32)
    target_link_libraries(csg mesh ${PYTHON_LIBRARIES})
    target_link_libraries(csg ${PYTHON_LIBRARIES})
    install( TARGETS csg ${NG_INSTALL_DIR})
endif(NOT WIN32)


if(USE_GUI)
    add_library(csgvis ${NG_LIB_TYPE} vscsg.cpp )
    if(NOT WIN32)
        target_link_libraries(csgvis csg visual)
        if(APPLE)
            set_target_properties( csgvis PROPERTIES SUFFIX ".so")
        endif(APPLE)
        install( TARGETS csgvis ${NG_INSTALL_DIR})
    endif(NOT WIN32)
endif(USE_GUI)

install(FILES
  algprim.hpp brick.hpp csgeom.hpp csg.hpp csgparser.hpp
  curve2d.hpp edgeflw.hpp explicitcurve2d.hpp extrusion.hpp
  gencyl.hpp geoml.hpp identify.hpp manifold.hpp meshsurf.hpp
  polyhedra.hpp revolution.hpp singularref.hpp solid.hpp
  specpoin.hpp spline3d.hpp splinesurface.hpp surface.hpp
  triapprox.hpp vscsg.hpp
  DESTINATION ${NG_INSTALL_DIR_INCLUDE}/csg COMPONENT netgen_devel
)

=== libsrc/general/CMakeLists.txt ===
add_definitions(-DNGINTERFACE_EXPORTS)
add_library(gen OBJECT
        array.cpp bitarray.cpp dynamicmem.cpp flags.cpp 
        hashtabl.cpp mystring.cpp ngexception.cpp optmem.cpp parthreads.cpp 
        profiler.cpp seti.cpp sort.cpp spbita2d.cpp symbolta.cpp table.cpp 
        mpi_interface.cpp gzstream.cpp
        )

set_target_properties( gen PROPERTIES POSITION_INDEPENDENT_CODE ON )

install( FILES ngexception.hpp DESTINATION ${NG_INSTALL_DIR_INCLUDE} COMPONENT netgen_devel )

install(FILES
  archive_base.hpp array.hpp autodiff.hpp autoptr.hpp bitarray.hpp
  dynamicmem.hpp flags.hpp hashtabl.hpp mpi_interface.hpp myadt.hpp
  ngsimd.hpp mystring.hpp netgenout.hpp ngexception.hpp ngpython.hpp
  optmem.hpp parthreads.hpp profiler.hpp seti.hpp sort.hpp
  spbita2d.hpp stack.hpp symbolta.hpp table.hpp template.hpp
  gzstream.h
  DESTINATION ${NG_INSTALL_DIR_INCLUDE}/general COMPONENT netgen_devel
)

=== libsrc/geom2d/CMakeLists.txt ===
add_definitions(-DNGLIB_EXPORTS)
add_library(geom2d ${NG_LIB_TYPE} genmesh2d.cpp geom2dmesh.cpp geometry2d.cpp python_geom2d.cpp )
if(APPLE)
    set_target_properties( geom2d PROPERTIES SUFFIX ".so")
endif(APPLE)

if(NOT WIN32)
    target_link_libraries(geom2d mesh ${PYTHON_LIBRARIES})
    install( TARGETS geom2d ${NG_INSTALL_DIR})
endif(NOT WIN32)

if(USE_GUI)
    add_library(geom2dvis ${NG_LIB_TYPE} vsgeom2d.cpp)
    if(NOT WIN32)
        target_link_libraries(geom2dvis geom2d)
        install( TARGETS geom2dvis ${NG_INSTALL_DIR})
    endif(NOT WIN32)
endif(USE_GUI)

install(FILES
  geom2dmesh.hpp geometry2d.hpp spline2d.hpp
  splinegeometry2.hpp vsgeom2d.hpp
  DESTINATION ${NG_INSTALL_DIR_INCLUDE}/geom2d COMPONENT netgen_devel
)

=== libsrc/gprim/CMakeLists.txt ===
add_definitions(-DNGINTERFACE_EXPORTS)
add_library(gprim OBJECT
        adtree.cpp geom2d.cpp geom3d.cpp geomfuncs.cpp 
        geomtest3d.cpp transform3d.cpp spline.cpp splinegeometry.cpp
        )

set_target_properties( gprim PROPERTIES POSITION_INDEPENDENT_CODE ON )

install(FILES
  adtree.hpp geom2d.hpp geom3d.hpp geomfuncs.hpp geomobjects2.hpp
  geomobjects.hpp geomops2.hpp geomops.hpp geomtest3d.hpp gprim.hpp
  splinegeometry.hpp spline.hpp transform3d.hpp
  DESTINATION ${NG_INSTALL_DIR_INCLUDE}/gprim COMPONENT netgen_devel
)

=== libsrc/include/CMakeLists.txt ===
install(FILES nginterface.h nginterface_v2.hpp mydefs.hpp DESTINATION ${NG_INSTALL_DIR_INCLUDE} COMPONENT netgen_devel)

install(FILES
  acisgeom.hpp csg.hpp geometry2d.hpp gprim.hpp incopengl.hpp
  inctcl.hpp incvis.hpp linalg.hpp meshing.hpp myadt.hpp mydefs.hpp
  mystdlib.h nginterface_v2_impl.hpp occgeom.hpp ngsimd.hpp
  opti.hpp parallel.hpp parallelinterface.hpp stlgeom.hpp visual.hpp
  DESTINATION ${NG_INSTALL_DIR_INCLUDE}/include COMPONENT netgen_devel
  )

=== libsrc/meshing/CMakeLists.txt ===
add_definitions(-DNGINTERFACE_EXPORTS)
if(NOT WIN32)
    set(mesh_object_libs 
        $<TARGET_OBJECTS:la>
        $<TARGET_OBJECTS:gprim>
        $<TARGET_OBJECTS:gen>
        )
endif(NOT WIN32)

add_library(mesh ${NG_LIB_TYPE}
        adfront2.cpp adfront3.cpp bisect.cpp boundarylayer.cpp 
        clusters.cpp curvedelems.cpp delaunay.cpp delaunay2d.cpp	    
        geomsearch.cpp global.cpp hprefinement.cpp improve2.cpp		    
        improve2gen.cpp improve3.cpp localh.cpp meshclass.cpp		    
        meshfunc.cpp meshfunc2d.cpp meshing2.cpp meshing3.cpp		    
        meshtool.cpp meshtype.cpp msghandler.cpp netrule2.cpp		    
        netrule3.cpp parser2.cpp parser3.cpp prism2rls.cpp		    
        pyramid2rls.cpp pyramidrls.cpp quadrls.cpp refine.cpp		    
        ruler2.cpp ruler3.cpp secondorder.cpp smoothing2.5.cpp		    
        smoothing2.cpp smoothing3.cpp specials.cpp tetrarls.cpp		    
        topology.cpp triarls.cpp validate.cpp bcfunctions.cpp   
        parallelmesh.cpp  paralleltop.cpp  paralleltop.hpp basegeom.cpp     
        python_mesh.cpp hexarls.cpp
        ../../ng/onetcl.cpp
        ${mesh_object_libs}
        )

if(APPLE)
    set_target_properties( mesh PROPERTIES SUFFIX ".so")
endif(APPLE)

if(NOT WIN32)
    target_link_libraries( mesh ${ZLIB_LIBRARIES} ${MPI_CXX_LIBRARIES} ${PYTHON_LIBRARIES} ${METIS_LIBRARY})
    install( TARGETS mesh ${NG_INSTALL_DIR})
endif(NOT WIN32)

install(FILES
  adfront2.hpp adfront3.hpp basegeom.hpp bcfunctions.hpp bisect.hpp
  boundarylayer.hpp classifyhpel.hpp clusters.hpp curvedelems.hpp
  findip2.hpp findip.hpp geomsearch.hpp global.hpp hpref_hex.hpp
  hprefinement.hpp hpref_prism.hpp hpref_pyramid.hpp hpref_quad.hpp
  hpref_segm.hpp hpref_tet.hpp hpref_trig.hpp improve2.hpp improve3.hpp
  localh.hpp meshclass.hpp meshfunc.hpp meshing2.hpp meshing3.hpp
  meshing.hpp meshtool.hpp meshtype.hpp msghandler.hpp paralleltop.hpp
  ruler2.hpp ruler3.hpp specials.hpp topology.hpp validate.hpp
  DESTINATION ${NG_INSTALL_DIR_INCLUDE}/meshing COMPONENT netgen_devel
)

=== libsrc/occ/CMakeLists.txt ===
add_definitions(-DNGINTERFACE_EXPORTS)
add_library(occ ${NG_LIB_TYPE}
        Partition_Inter2d.cxx Partition_Inter3d.cxx 
        Partition_Loop.cxx Partition_Loop2d.cxx Partition_Loop3d.cxx Partition_Spliter.cxx 
        occconstruction.cpp occgenmesh.cpp occgeom.cpp occmeshsurf.cpp python_occ.cpp
        )

add_library(occvis ${NG_LIB_TYPE} vsocc.cpp)

if(NOT WIN32)
    target_link_libraries( occ ${OCC_LIBRARIES} ${PYTHON_LIBRARIES})
    target_link_libraries( occvis occ )
    install( TARGETS occ occvis ${NG_INSTALL_DIR})
endif(NOT WIN32)

install(FILES
  occgeom.hpp occmeshsurf.hpp vsocc.hpp
  DESTINATION ${NG_INSTALL_DIR_INCLUDE}/occ COMPONENT netgen_devel
)

=== debian/changelog ===
netgen (6.2.1804+dfsg1-3build2) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 23 Mar 2020 07:20:38 +0100

netgen (6.2.1804+dfsg1-3build1) focal; urgency=medium

  * No-change rebuild to build with python3.8.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 25 Jan 2020 05:42:26 +0000

netgen (6.2.1804+dfsg1-3) unstable; urgency=medium

  * [425e45e] Use new OpenCASCADE path

 -- Kurt Kremitzki <kurt@kwk.systems>  Fri, 01 Mar 2019 12:44:35 -0600

netgen (6.2.1804+dfsg1-2) unstable; urgency=medium

  * [a2eccc0] Disable native arch builds

 -- Kurt Kremitzki <kurt@kwk.systems>  Fri, 28 Dec 2018 21:48:38 -0600

netgen (6.2.1804+dfsg1-1) unstable; urgency=medium

  * [86ccafe] Fix missing libnglib dependency for netgen binary

 -- Kurt Kremitzki <kurt@kwk.systems>  Fri, 03 Aug 2018 20:19:51 -0500

netgen (6.2.1804+dfsg1-1~exp2) experimental; urgency=medium

  * Add SSE guard patch to fix non-x86 builds
  * Only use MPI on appropriate build arches

 -- Kurt Kremitzki <kurt@kwk.systems>  Fri, 27 Jul 2018 13:48:52 -0500

netgen (6.2.1804+dfsg1-1~exp1) experimental; urgency=medium

  [ Kurt Kremitzki ]
  * Updated for upstream release 6.2.1804
  * Changed dependency from liboce->libocct
  * Autotools->cmake
  * Support for Python 3 bindings package python3-netgen

  [ Anton Gladky ]
  * Remove myself from uploaders

 -- Kurt Kremitzki <kkremitzki@gmail.com>  Sat, 09 Jun 2018 17:32:28 -0500

netgen (4.9.13.dfsg-11) unstable; urgency=medium

  * [f9d1707] Disable deprecated in oce functions

 -- Anton Gladky <gladk@debian.org>  Thu, 21 Sep 2017 21:17:40 +0200

=== debian/control ===
Source: netgen
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: "Adam C. Powell, IV" <hazelsct@debian.org>,
           Kurt Kremitzki <kurt@kwk.systems>
Section: math
Priority: optional
Build-Depends: cmake,
               debhelper (>= 11),
               dh-python,
               libtool,
               tcl-dev,
               tk-dev,
               tix-dev,
               docbook-to-man,
               libxmu-dev,
               libglu1-mesa-dev,
               libmetis-dev,
               libocct-data-exchange-dev,
               libocct-foundation-dev,
               libocct-visualization-dev,
               libocct-ocaf-dev,
               libopenmpi-dev,
               libtogl-dev,
               libswscale-dev,
               libjpeg-dev,
               libbz2-dev,
               pybind11-dev,
               python3-dev,
               python3-dbg
Standards-Version: 4.1.4
Vcs-Browser: https://salsa.debian.org/science-team/netgen
Vcs-Git: https://salsa.debian.org/science-team/netgen.git
Homepage: https://ngsolve.org

Package: netgen
Architecture: any
Depends: libnglib-6.2.1804 (= ${binary:Version}),
         tix,
         ${shlibs:Depends},
         ${misc:Depends}
Suggests: netgen-doc
Description: Automatic 3d tetrahedral mesh generator
 NETGEN is an automatic 3d tetrahedral mesh generator. It accepts
 input from constructive solid geometry (CSG) or boundary
 representation (BRep) from STL file format.  NETGEN contains modules
 for mesh optimization and hierarchical mesh refinement.

Package: netgen-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Suggests: netgen
Description: Automatic 3d tetrahedral mesh generator documentation
 NETGEN is an automatic 3d tetrahedral mesh generator. It accepts
 input from constructive solid geometry (CSG) or boundary
 representation (BRep) from STL file format.  NETGEN contains modules
 for mesh optimization and hierarchical mesh refinement.
 .
 This package contains the user manual (in PDF format) and example
 files.

Package: libnglib-dev
Architecture: any
Section: libdevel
Depends: libnglib-6.2.1804 (= ${binary:Version}),
         ${misc:Depends}
Description: Automatic 3d tetrahedral mesh generator development files
 NETGEN is an automatic 3d tetrahedral mesh generator. It accepts
 input from constructive solid geometry (CSG) or boundary
 representation (BRep) from STL file format. The connection to a
 geometry kernel allows the handling of IGES and STEP files. NETGEN
 contains modules for mesh optimization and hierarchical mesh
 refinement.
 .
 This package contains the static libraries and header files.

Package: libnglib-6.2.1804
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Automatic 3d tetrahedral mesh generator shared library
 NETGEN is an automatic 3d tetrahedral mesh generator. It accepts
 input from constructive solid geometry (CSG) or boundary
 representation (BRep) from STL file format. The connection to a
 geometry kernel allows the handling of IGES and STEP files. NETGEN
 contains modules for mesh optimization and hierarchical mesh
 refinement.
 .
 This package contains the shared libraries.

Package: netgen-headers
Architecture: any
Section: libdevel
Depends: libnglib-dev (= ${binary:Version}),
         ${misc:Depends}
Description: Automatic 3d tetrahedral mesh generator internal headers
 NETGEN is an automatic 3d tetrahedral mesh generator. It accepts
 input from constructive solid geometry (CSG) or boundary
 representation (BRep) from STL file format. The connection to a
 geometry kernel allows the handling of IGES and STEP files. NETGEN
 contains modules for mesh optimization and hierarchical mesh
 refinement.
 .
 This package contains internal headers.

Package: python3-netgen
Architecture: any
Section: python
Depends: libnglib-6.2.1804 (= ${binary:Version}),
         ${shlibs:Depends},
         ${misc:Depends},
         ${python3:Depends}
Pre-Depends: ${misc:Pre-Depends}
Provides: ${python3:Provides}
Description: Automatic 3d tetrahedral mesh generator Python 3 bindings
 NETGEN is an automatic 3d tetrahedral mesh generator. It accepts
 input from constructive solid geometry (CSG) or boundary
 representation (BRep) from STL file format. The connection to a
 geometry kernel allows the handling of IGES and STEP files. NETGEN
 contains modules for mesh optimization and hierarchical mesh
 refinement.
 .
 This package contains Python 3 bindings.

## netgen 6.2.2006%2Breally6.2.1905%2Bdfsg

=== libsrc/general/CMakeLists.txt ===
add_definitions(-DNGINTERFACE_EXPORTS)
add_library(gen INTERFACE)
set(sdir ${CMAKE_CURRENT_SOURCE_DIR})
target_sources(gen INTERFACE
  ${sdir}/array.cpp ${sdir}/bitarray.cpp ${sdir}/dynamicmem.cpp ${sdir}/flags.cpp
        ${sdir}/hashtabl.cpp ${sdir}/mystring.cpp ${sdir}/optmem.cpp ${sdir}/parthreads.cpp
        ${sdir}/seti.cpp ${sdir}/sort.cpp ${sdir}/spbita2d.cpp ${sdir}/table.cpp
        ${sdir}/mpi_interface.cpp ${sdir}/gzstream.cpp
        )

install(FILES
  array.hpp autodiff.hpp autoptr.hpp bitarray.hpp
  dynamicmem.hpp flags.hpp hashtabl.hpp mpi_interface.hpp myadt.hpp
  ngsimd.hpp mystring.hpp netgenout.hpp ngpython.hpp
  optmem.hpp parthreads.hpp seti.hpp sort.hpp
  spbita2d.hpp stack.hpp table.hpp template.hpp
  gzstream.h
  DESTINATION ${NG_INSTALL_DIR_INCLUDE}/general COMPONENT netgen_devel
)

=== debian/changelog ===
netgen (6.2.2006+really6.2.1905+dfsg-5build1) jammy; urgency=medium

  * No-change rebuild with Python 3.10 as default version

 -- Graham Inggs <ginggs@ubuntu.com>  Thu, 13 Jan 2022 20:10:01 +0000

netgen (6.2.2006+really6.2.1905+dfsg-5) unstable; urgency=medium

  * [a301dc9] Add upstream arm pickling fix patch (Closes: #995416)

 -- Kurt Kremitzki <kkremitzki@debian.org>  Tue, 04 Jan 2022 23:26:20 -0600

netgen (6.2.2006+really6.2.1905+dfsg-4) unstable; urgency=medium

  * [cf1e0f1] Add build-needed restriction for autopkgtest

 -- Kurt Kremitzki <kkremitzki@debian.org>  Tue, 07 Sep 2021 23:57:11 -0500

netgen (6.2.2006+really6.2.1905+dfsg-3) unstable; urgency=medium

  * [ed9fb04] Add catch2 dep for tests
  * [4ae0642] Add patch to use Debian copy of catch2
  * [6f8a1dd] Add build flags to enable unit tests
  * [6d4e460] Update autopkgtest to use upstream tests instead of superficial
    import (Closes: #993533)

 -- Kurt Kremitzki <kkremitzki@debian.org>  Mon, 06 Sep 2021 23:05:56 -0500

netgen (6.2.2006+really6.2.1905+dfsg-2) unstable; urgency=medium

  [ Christophe Trophime ]
  * [5426125] Fix running tests
  * [96e65ea] Fix rules

  [ Kurt Kremitzki ]
  * [3456ac2] Replace spaces with tabs
  * [3fdb5a6] Add python3-numpy dep
  * [92e131e] Add python3-tk dep
  * [bb4e28b] Remove --parallel flag already set by current compat level
  * [3fb3792] Note that public domain license is verbatim

 -- Kurt Kremitzki <kkremitzki@debian.org>  Mon, 21 Dec 2020 14:21:12 -0600

netgen (6.2.2006+really6.2.1905+dfsg-1) unstable; urgency=medium

  * [ec0fdfc] New upstream version 6.2.2006+really6.2.1905+dfsg
  * [68c2282] Refresh patches
  * [9d5c4b3] Add missing libocct-modeling-algorithms-dev dep
  * [b0be36e] Add patch for OCCT 7.4
  * [d394f7b] Add patch to support non-x86 builds (Closes: #975089, #974136)
  * [59c007a] Update netgen-headers install file
  * [6b37be2] Remove unneeded override
  * [5b49923] Add mpi-default-bin dep (Closes: #935797)
  * [8c662eb] Revise documentation of copyright (Closes: #968731)

 -- Kurt Kremitzki <kkremitzki@debian.org>  Thu, 19 Nov 2020 14:00:15 -0600

netgen (6.2.2006+dfsg-1) unstable; urgency=medium

  * [dfab5bc] Update Files-Excluded for bundled togl copies
  * [a5108b5] New upstream version 6.2.2006+dfsg
  * [2041bca] Add lintian-overrides for maintainer email
  * [f63cbb6] Update to Standards-Version 4.5.0
  * [0b90601] Add debian/ to d/copyright
  * [a18675c] Add remove-git-dep.patch
  * [1e74503] Add remove-togl.patch
  * [d5374dc] Refresh patches
  * [cbaae27] Update installation files
  * [c1fa496] Add fix-version.patch
  * [06c2783] Refresh patches
  * [74b6427] fix lgpl-2+ standalone license and hardcoded version
  * [8cf8e81] Correct Uploaders email
  * [fd97ebf] Add fix-national-encoding.patch
  * [3afb0a5] Fix desktop file

 -- Kurt Kremitzki <kkremitzki@debian.org>  Sun, 09 Aug 2020 16:46:38 -0500

netgen (6.2.1905+dfsg1-1) unstable; urgency=medium

  * [b11ff5d] New upstream version 6.2.1905+dfsg1
  * [962d15c] Fix opencascade include path
  * [b3ffab5] Add fix-pybind11-include.patch
  * [d600d49] Update missing files

 -- Kurt Kremitzki <kurt@kwk.systems>  Sun, 21 Jul 2019 01:32:26 -0500

netgen (6.2.1810+dfsg1-1) unstable; urgency=medium

  [ Kurt Kremitzki ]
  * [bcd99bb] New upstream version 6.2.1810+dfsg1
  * [89d2030] Add Replaces to handle libnglib rename

  [ Anton Gladky ]
  * [c08e683] Add Breaks-section in d/control


 -- Kurt Kremitzki <kurt@kwk.systems>  Sun, 27 Jan 2019 04:12:57 -0600
